package router

import (
	"fmt"
	"git.168cad.top/zhengqiuyun/rym-util/conf"
	"git.168cad.top/zhengqiuyun/rym-util/log"
	"git.168cad.top/zhengqiuyun/rym-util/router/validator"
	"git.168cad.top/zhengqiuyun/rym-util/util"
	"github.com/gin-gonic/gin"
	"github.com/gin-gonic/gin/render"
	"github.com/swaggo/files"
	"github.com/swaggo/gin-swagger"
	"net/http"
)

func InitGinEngine() *gin.Engine {
	gin.SetMode(gin.ReleaseMode)
	c := gin.New()
	//便于工具监测
	c.GET("/favicon.ico", func(c *gin.Context) {
		c.Render(http.StatusOK, render.String{})
	})
	//自定义验证器
	validator.RegisterValidate()
	if conf.Env == "dev" || conf.Env == "test" {
		//swagger
		c.GET("/swagger/*any", ginSwagger.WrapHandler(swaggerFiles.Handler))
		log.Info("swagger init success")
	}
	return c
}

func Run(c *gin.Engine) {
	portAddr := ""
	arg1 := util.Args(1)
	if arg1 == "" {
		portAddr = fmt.Sprintf(":%d", conf.HttpPort)
	} else {
		portAddr = fmt.Sprintf(":%s", arg1)
	}
	log.Info(fmt.Sprintf("web start in port%s", portAddr))
	err := c.Run(portAddr)
	if err != nil {
		panic(err)
	}
}
